searchNodes=[{"ref":"AppOptex.html","title":"AppOptex","module":"AppOptex","type":"module","doc":"Client library for sending and reading AppOptics API measurements. To auth AppOptics make sure to set the APPOPTICS_TOKEN environment variable. This can also be overridden in the Application config."},{"ref":"AppOptex.html#flush_queue/0","title":"AppOptex.flush_queue/0","module":"AppOptex","type":"function","doc":"Asynchronously send the contents of the queue to AppOptics and clear it. Examples iex&gt; AppOptex.flush_queue() :ok"},{"ref":"AppOptex.html#get_global_tags/0","title":"AppOptex.get_global_tags/0","module":"AppOptex","type":"function","doc":"Get the global tags that will be applied to all measurements. Examples iex&gt; AppOptex.get_global_tags() %{my_tag: &quot;value&quot;}"},{"ref":"AppOptex.html#measurement/2","title":"AppOptex.measurement/2","module":"AppOptex","type":"function","doc":"Send one measurement with tags. The measurements are sent to AppOptics asynchronously. measurement - Map of the measurement data tags - A map of tags to send with the measurement. Cannot be empty. Examples iex&gt; AppOptex.measurement(%{name: &quot;my.mertic&quot;, value: 10}, %{my_tag: &quot;value&quot;}) :ok"},{"ref":"AppOptex.html#measurement/3","title":"AppOptex.measurement/3","module":"AppOptex","type":"function","doc":"Send one measurement with tags. The measurements are sent to AppOptics asynchronously. name - Name of the measurement value - Value of the measurement tags - A map of tags to send with the measurement. Cannot be empty. Examples iex&gt; AppOptex.measurement(&quot;my.mertic&quot;, 10, %{my_tag: &quot;value&quot;}) :ok"},{"ref":"AppOptex.html#measurements/2","title":"AppOptex.measurements/2","module":"AppOptex","type":"function","doc":"Send multiple measurements with tags. The measurements are sent to AppOptics asynchronously. measurements - a batch of metrics to send as a list of maps. tags - A map of tags to send with the measurement. Cannot be empty. Examples iex&gt; AppOptex.measurements([%{name: &quot;my.mertic&quot;, value: 1}, %{name: &quot;my.other_mertic&quot;, value: 5}], %{my_tag: &quot;value&quot;}) :ok"},{"ref":"AppOptex.html#push_to_queue/2","title":"AppOptex.push_to_queue/2","module":"AppOptex","type":"function","doc":"Asynchronously add to queue of measurements to be sent to AppOptics later. Examples iex&gt; AppOptex.push_to_queue([%{name: &quot;my.metric&quot;, value: 1}], %{test: true}) :ok"},{"ref":"AppOptex.html#put_global_tags/1","title":"AppOptex.put_global_tags/1","module":"AppOptex","type":"function","doc":"Set the global tags that will be applied to all measurements. These can be overriden by tags provided in measurement/3 and measurements/2. tags - maps of tags to set. Examples iex&gt; AppOptex.put_global_tags(%{my_tag: &quot;value&quot;}) :ok"},{"ref":"AppOptex.html#read_measurements/3","title":"AppOptex.read_measurements/3","module":"AppOptex","type":"function","doc":"Recieve multiple measurements with tags. The measurements are read from AppOptics synchronously. metric name - the name of the metric you want measurements on. resolution - the resolution of the measurements in seconds. params - A map of parameters to restrict the result to possible values include: start_time - Unix Time of where to start the time search from. This parameter is optional if duration is specified. end_time - Unix Time of where to end the search. This parameter is optional and defaults to current wall time. duration - How far back to look in time, measured in seconds. This parameter can be used in combination with endtime to set a starttime N seconds back in time. It is an error to set starttime, endtime and duration. Examples iex&gt; AppOptex.client.read_measurements(&quot;my.other_mertic&quot;, 60, %{duration: 999999}) %{ &quot;attributes&quot; =&gt; %{&quot;created_by_ua&quot; =&gt; &quot;hackney/1.15.1&quot;}, &quot;links&quot; =&gt; [], &quot;name&quot; =&gt; &quot;my.other_mertic&quot;, &quot;resolution&quot; =&gt; 60, &quot;series&quot; =&gt; [ %{ &quot;measurements&quot; =&gt; [%{&quot;time&quot; =&gt; 1554720060, &quot;value&quot; =&gt; 10.0}], &quot;tags&quot; =&gt; %{&quot;my_tag&quot; =&gt; &quot;value&quot;} } ] }"},{"ref":"AppOptex.html#read_queue/0","title":"AppOptex.read_queue/0","module":"AppOptex","type":"function","doc":"Return the current contents of the measurements queue. The queue format is a list of tuples, each tuple contains a measurements list and a tags map. Examples iex&gt; AppOptex.read_queue [{[%{name: &quot;my.metric&quot;, value: 1}], %{test: true}}]"},{"ref":"AppOptex.Client.html","title":"AppOptex.Client","module":"AppOptex.Client","type":"module","doc":"Module responsible for comunication with AppOptics API."},{"ref":"AppOptex.Client.html#read_measurements/5","title":"AppOptex.Client.read_measurements/5","module":"AppOptex.Client","type":"function","doc":"Read from AppOptics retrieve measurement API given a query. Returns the AppOptex API response. appoptics_url - AppOptics API endpoint. token - AppOptics auth token. metric_name - Name of the metric to search. resolution - Defines the resolution to return the data to in seconds. query - map of query params. Must include either duration or start_time. Params include: start_time - Unix Time of where to start the time search from. This parameter is optional if duration is specified. end_time - Unix Time of where to end the search. This parameter is optional and defaults to current wall time. duration - How far back to look in time, measured in seconds. This parameter can be used in combination with endtime to set a starttime N seconds back in time. It is an error to set starttime, endtime and duration. Examples iex&gt; AppOptex.Client.read_measurements(&quot;https://api.appoptics.com/v1/measurements&quot;, &quot;MY_TOKEN&quot;, &quot;my.other_mertic&quot;, 60, %{duration: 999999}) %{ &quot;attributes&quot; =&gt; %{&quot;created_by_ua&quot; =&gt; &quot;hackney/1.15.1&quot;}, &quot;links&quot; =&gt; [], &quot;name&quot; =&gt; &quot;my.other_mertic&quot;, &quot;resolution&quot; =&gt; 60, &quot;series&quot; =&gt; [ %{ &quot;measurements&quot; =&gt; [%{&quot;time&quot; =&gt; 1554667320, &quot;value&quot; =&gt; 5.0}], &quot;tags&quot; =&gt; %{&quot;my_tag&quot; =&gt; &quot;value&quot;} } ] }"},{"ref":"AppOptex.Client.html#send_measurements/4","title":"AppOptex.Client.send_measurements/4","module":"AppOptex.Client","type":"function","doc":"Send an HTTP request to AppOptics create API with a list of measurements and tags. Returns the response from AppOptics API. appoptics_url - AppOptics API endpoint. token - AppOptics auth token. measurements - List of measurements to send. Each measurements is a map with a name and a value key. tags - A map of tags to send for the current measurement. Examples iex&gt; AppOptex.Client.send_measurements(&quot;https://api.appoptics.com/v1/measurements&quot;, &quot;MY_TOKEN&quot;, [%{name: &quot;my.mertric.name&quot;, value: 1}], %{&quot;name&quot; =&gt; &quot;value&quot;}) {:ok, %HTTPoison.Response{}}"},{"ref":"AppOptex.Queue.html","title":"AppOptex.Queue","module":"AppOptex.Queue","type":"module","doc":""},{"ref":"AppOptex.Queue.html#batch_queue/1","title":"AppOptex.Queue.batch_queue/1","module":"AppOptex.Queue","type":"function","doc":""},{"ref":"AppOptex.Worker.html","title":"AppOptex.Worker","module":"AppOptex.Worker","type":"module","doc":"GenServer implementation used for asynchronous communication"},{"ref":"AppOptex.Worker.html#child_spec/1","title":"AppOptex.Worker.child_spec/1","module":"AppOptex.Worker","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"AppOptex.Worker.html#init/1","title":"AppOptex.Worker.init/1","module":"AppOptex.Worker","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"AppOptex.Worker.html#start_link/1","title":"AppOptex.Worker.start_link/1","module":"AppOptex.Worker","type":"function","doc":""}]